HDU 1045——Fire Net——————【最大匹配、构图、邻接矩阵做法】

Fire Net
Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u

Description

Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall. 

A blockhouse is a small castle that has four openings through which to shoot. The four openings are facing North, East, South, and West, respectively. There will be one machine gun shooting through each opening. 

Here we assume that a bullet is so powerful that it can run across any distance and destroy a blockhouse on its way. On the other hand, a wall is so strongly built that can stop the bullets. 

The goal is to place as many blockhouses in a city as possible so that no two can destroy each other. A configuration of blockhouses is legal provided that no two blockhouses are on the same horizontal row or vertical column in a map unless there is at least one wall separating them. In this problem we will consider small square cities (at most 4x4) that contain walls through which bullets cannot run through. 

The following image shows five pictures of the same board. The first picture is the empty board, the second and third pictures show legal configurations, and the fourth and fifth pictures show illegal configurations. For this board, the maximum number of blockhouses in a legal configuration is 5; the second picture shows one way to do it, but there are several other ways. 

HDU 1045——Fire Net——————【最大匹配、构图、邻接矩阵做法】

Your task is to write a program that, given a description of a map, calculates the maximum number of blockhouses that can be placed in the city in a legal configuration. 
 

Input

The input file contains one or more map descriptions, followed by a line containing the number 0 that signals the end of the file. Each map description begins with a line containing a positive integer n that is the size of the city; n will be at most 4. The next n lines each describe one row of the map, with a '.' indicating an open space and an uppercase 'X' indicating a wall. There are no spaces in the input file. 
 

Output

For each test case, output one line containing the maximum number of blockhouses that can be placed in the city in a legal configuration.
 

Sample Input

4
.X..
....
XX..
....
2
XX
.X
3
.X.
X.X
.X.
3
...
.XX
.XX
4
....
....
....
....
0
 

Sample Output

5
1
5
2
4

题目大意:给你n*n的矩阵,里面有些位置有墙。要在空地方放上炮弹,导弹会攻击上下左右四个方向,导弹的攻击不能通过墙即碰到墙就停止了。问你最多能在里面放入多少个炮弹。

解题思路:由于有墙的阻隔,所以不能简单地将行列直接分为二部。所以考虑一行中,如果遇到墙,可以认为是已经换行了,让行数加一。同样,列也这样考虑。在我们呢这种意义下的行列有交汇的地方,连一条边。求最大匹配。

#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<iostream>
using namespace std;
int vis[110][110], G[110][110], linker[110], used[110];
char Map[110][110];
bool dfs(int u,int _n){
    for(int v = 1; v <= _n; v++){
        if(G[u][v] && !used[v]){
            used[v] = u;
            if(linker[v] == -1 || dfs(linker[v],_n)){
                linker[v] = u;
                return true;
            }
        }
    }
    return false;
}
int hungary(int un,int vn){
    int ret = 0;
    memset(linker,-1,sizeof(linker));
    for(int i = 1; i <= un; i++){
        memset(used,0,sizeof(used));
        if(dfs(i,vn))
            ret++;
    }
    return ret;
}
int main(){
    int n;
    while(scanf("%d",&n)!=EOF&&n){

        for(int i = 1; i <= n; i++){
            getchar();
            for(int j = 1; j <= n; j++){
                scanf("%c",&Map[i][j]);
            }
        }
        memset(vis,0,sizeof(vis));
        int vn = 0, flag;
        for(int i = 1; i <= n; i++){
            flag = 1;
            for(int j = 1; j <= n; j++){
                if(Map[i][j] == 'X'){
                    flag = 1;
                }else{
                    if(flag) {
                        vn++;
                        flag = 0;
                    }
                    vis[i][j] = vn;
                }
            }
        }
        memset(G,0,sizeof(G));
        int un = 0;
        for(int j = 1; j <= n; j++){
            flag = 1;
            for(int i = 1; i <= n; i++){
                if(Map[i][j] == 'X'){
                    flag = 1;
                }else{
                    if(flag){
                        un++;
                        flag = 0;
                    }
                    G[un][vis[i][j]] = 1;
                }
            }
        }
        int ans = hungary(un,vn);
        printf("%d
",ans);
    }
    return 0;
}